#!/usr/bin/python

import sys
import os

if len(sys.argv) == 1:
	print "Usage: vstc.py [-e] [-d targetDir] file1 [-[target1]] file2 ..."
	print "  -e  encrypt the files instead of decrypting"
	print "  -d  output files into this directory"
	print "If the target is -, the file is encrypted/decrypted in place."
	sys.exit()

def decrypt(char,key):
	"Decrypting..."
	x = ord(char)
	x -= shift
	while x not in range(256): x += 256
	x = chr(x)
	return x

def encrypt(char,key):
	"Encrypting..."
	x = ord(char)
	x += shift
	while x not in range(256): x -= 256
	x = chr(x)
	return x

files = sys.argv[1:]
targetDir = "%"
transform = decrypt
if files[0] == '-e':
	transform = encrypt
	files = files[1:]
if '-d' in files:
	i = 0
	while i < len(files):
		if files[i] == '-d':
			break
		i += 1
	targetDir = files[i+1]
	del files[i:i+2]

transfers = []
for i in range(0,len(files)-1):
	if files[i+1][0] == '-':
		# Output file explicitly given
		if files[i+1] == '-':
			transfers.append( {'src':files[i], 'dst':files[i]} )
		else:
			transfers.append( {'src':files[i], 'dst':files[i+1][1:]} )
		i += 1
	else:
		if targetDir == "%":
			transfers.append( {'src':files[i], 'dst':sys.stdin} )
		else:
			# Extract filename
			fname = os.path.split(files[i])[1]
			if fname == "":
				sys.exit("Error: %s is not a file." % files[i])
			transfers.append( {'src':files[i], 'dst':os.path.join(targetDir,fname)} )
	i += 1
outfile = sys.stdout

print transform.__doc__
for path in transfers:
	try:
		scriptFile = open(path['src'],'r')
	except:
		print sys.exc_type
		print sys.exc_value
		sys.exit()
	cipher = scriptFile.read()
	scriptFile.close()
	
	key = len(cipher)/2
	shift = ord(cipher[key]); # now shift all OTHER bytes by this amount
	
	script = ""
	
	for x in cipher[:key]:
		script += transform(x,key)
	
	script += cipher[key]
	
	for x in cipher[key+1:]:
		script += transform(x,key)
	
	outfile = open(path['dst'],'w')
	outfile.write(script)
	outfile.close()